<script>
import { GlSprintf, GlLink, GlButton } from '@gitlab/ui';
import { s__, sprintf } from '~/locale';
import { numberToHumanSize } from '~/lib/utils/number_utils';
import { usageQuotasHelpPaths } from '~/usage_quotas/storage/constants';
import { BUY_STORAGE, NAMESPACE_STORAGE_OVERVIEW_SUBTITLE } from '../constants';
import StorageStatisticsCard from './storage_statistics_card.vue';
import TotalStorageAvailableBreakdownCard from './total_storage_available_breakdown_card.vue';
import ExcessStorageBreakdownCard from './excess_storage_breakdown_card.vue';

export default {
  components: {
    GlSprintf,
    GlLink,
    GlButton,
    StorageStatisticsCard,
    TotalStorageAvailableBreakdownCard,
    ExcessStorageBreakdownCard,
  },
  inject: [
    'purchaseStorageUrl',
    'buyAddonTargetAttr',
    'namespacePlanName',
    'isUsingProjectEnforcement',
    'namespacePlanStorageIncluded',
  ],
  props: {
    additionalPurchasedStorageSize: {
      type: Number,
      required: false,
      default: 0,
    },
    usedStorage: {
      type: Number,
      required: false,
      default: 0,
    },
    loading: {
      type: Boolean,
      required: true,
    },
  },
  i18n: {
    purchaseButtonText: BUY_STORAGE,
    namespaceStorageOverviewSubtitle: NAMESPACE_STORAGE_OVERVIEW_SUBTITLE,
  },
  computed: {
    enforcementTypei18n() {
      const namespaceEnforcementTypeTitle = s__('UsageQuota|Included in %{planName} subscription');
      const namespaceEnforcementTypeSubtitle = s__(
        'UsageQuota|This namespace has %{planLimit} of storage. %{linkStart}How are limits applied?%{linkEnd}',
      );
      const projectEnforcementTypeTitle = s__(
        'UsageQuota|Storage per project included in %{planName} subscription',
      );
      const projectEnforcementTypeSubtitle = s__(
        'UsageQuota|Projects under this namespace have %{planLimit} of storage. %{linkStart}How are limits applied?%{linkEnd}',
      );

      const i18nObject = this.isUsingProjectEnforcement
        ? {
            title: sprintf(projectEnforcementTypeTitle, {
              planName: this.namespacePlanName,
            }),
            subtitle: sprintf(projectEnforcementTypeSubtitle, {
              planLimit: numberToHumanSize(this.namespacePlanStorageIncluded, 1),
            }),
            learnMoreUrl: usageQuotasHelpPaths.usageQuotasProjectStorageLimit,
          }
        : {
            title: sprintf(namespaceEnforcementTypeTitle, {
              planName: this.namespacePlanName,
            }),
            subtitle: sprintf(namespaceEnforcementTypeSubtitle, {
              planLimit: numberToHumanSize(this.namespacePlanStorageIncluded, 1),
            }),
            learnMoreUrl: usageQuotasHelpPaths.usageQuotasNamespaceStorageLimit,
          };

      return {
        ...i18nObject,
        subtitle: this.namespacePlanStorageIncluded ? i18nObject.subtitle : '',
      };
    },
    totalStorage() {
      return this.namespacePlanStorageIncluded + this.additionalPurchasedStorageSize;
    },
  },
};
</script>
<template>
  <div>
    <div class="gl-display-flex gl-justify-content-space-between gl-align-items-center">
      <h3 data-testid="overview-subtitle">{{ $options.i18n.namespaceStorageOverviewSubtitle }}</h3>

      <gl-button
        v-if="purchaseStorageUrl && !isUsingProjectEnforcement"
        :href="purchaseStorageUrl"
        :target="buyAddonTargetAttr"
        category="primary"
        variant="confirm"
        data-testid="purchase-more-storage"
      >
        {{ $options.i18n.purchaseButtonText }}
      </gl-button>
    </div>
    <p class="gl-mb-0">
      <gl-sprintf :message="enforcementTypei18n.subtitle">
        <template #link="{ content }">
          <gl-link :href="enforcementTypei18n.learnMoreUrl">{{ content }}</gl-link>
        </template>
      </gl-sprintf>
    </p>
    <div class="gl-display-flex gl-sm-flex-direction-column gl-gap-5 gl-py-4">
      <storage-statistics-card
        :plan-storage-description="enforcementTypei18n.title"
        :used-storage="usedStorage"
        :total-storage="totalStorage"
        :loading="loading"
        data-testid="namespace-usage-total"
        class="gl-w-full"
      />
      <template v-if="namespacePlanName">
        <excess-storage-breakdown-card
          v-if="isUsingProjectEnforcement"
          :purchased-storage="additionalPurchasedStorageSize"
          :loading="loading"
        />
        <total-storage-available-breakdown-card
          v-else
          :plan-storage-description="enforcementTypei18n.title"
          :included-storage="namespacePlanStorageIncluded"
          :purchased-storage="additionalPurchasedStorageSize"
          :total-storage="totalStorage"
          :loading="loading"
        />
      </template>
    </div>
  </div>
</template>
